package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingEspecificoAgenciaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_PricingEspecificoAgencia;
import com.rjconsultores.ventaboletos.service.GP_PricingEspecificoAgenciaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingEspecificoAgenciaService")
public class GP_PricingEspecificoAgenciaServiceImpl implements GP_PricingEspecificoAgenciaService {
    @Autowired
    private GP_PricingEspecificoAgenciaDAO pricingEspecificoAgenciaDAO;
    
	@Override
	public List<GP_PricingEspecificoAgencia> obtenerTodos() {
		return pricingEspecificoAgenciaDAO.obtenerTodos();
	}

	@Override
	public GP_PricingEspecificoAgencia obtenerID(Long id) {
		return pricingEspecificoAgenciaDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public GP_PricingEspecificoAgencia suscribir(GP_PricingEspecificoAgencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setActivo(Boolean.TRUE);

        return pricingEspecificoAgenciaDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public GP_PricingEspecificoAgencia actualizacion(GP_PricingEspecificoAgencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());

		return pricingEspecificoAgenciaDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(GP_PricingEspecificoAgencia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingEspecificoAgenciaDAO.actualizacion(entidad);
	}
	@Override
	public Boolean existeAgenciaPricing (GP_PricingEspecificoAgencia entidad){
		return pricingEspecificoAgenciaDAO.isDuplicado(entidad);
	}

}
